import joi, { ObjectSchema } from 'joi';
import {isRequired} from "../validatorUtils";

export default (): ObjectSchema => joi.object({
  idDatiContratto: isRequired(joi.alternatives().try(joi.string(), joi.number())),
  indirizzoAttivazione: joi.string().required(),
  tipoIndirizzoAttivazione: joi.string().required(),
  numeroCivicoAttivazione: joi.string().required(),
  comuneAttivazione: joi.string().required(),
  capAttivazione: joi.string().required(),
  tipoContratto: joi.string().required(),
  precedenteOperatore: joi.string().required(),
  nomeAltroOperatore: joi.string().allow(null),
  usiInternet: joi.array().min(0).items(joi.string()).required(),
  interessiInternet: joi.array().min(0).items(joi.string()).required(),
  pacchetto: joi.string().required(),
  tipoInstallazione: joi.string().required(),
  ripetitoreWifi: joi.string().required(),
  router: joi.string().required(),
  numeroDiTelefono: joi.string().allow(null),
  codiceMigrazione: joi.string().allow(null),
  intestatarioLineaTelefonicaDiversoDaQuelloDellaConnessioneEOLO: joi.number().required(),
  tipoIntestatario: joi.string(),
  nomeIntestatarioLineaTelefonica: joi.string().allow(null),
  cognomeIntestatarioLineaTelefonica: joi.string().allow(null),
  comuneDiNascitaIntestatarioLineaTelefonica: joi.string().allow(null),
  codiceFiscaleIntestatarioLineaTelefonica: joi.string().allow(null),
  emailIntestatarioLineaTelefonica: joi.string().allow(null),
  cellulareIntestatarioLineaTelefonica: joi.string().allow(null),
  nomeIntestatario: joi.string().required(),
  cognomeIntestatario: joi.string().required(),
  ragioneSocialeIntestatario: joi.string().allow(null),
  pivaIntestatario: joi.string().allow(null),
  cciaaIntestatario: joi.string().allow(null),
  emailIntestatario: joi.string().required(),
  codiceFiscaleIntestatario: joi.string().required(),
  tipoIndirizzoIntestatario: joi.string().allow(null),
  indirizzoIntestatario: joi.string().allow(null),
  civicoIntestatario: joi.string().allow(null),
  capIntestatario: joi.string().allow(null),
  dataDiNascitaIntestatario: joi.string().required(),
  comuneDiNascitaIntestatario: joi.string().required(),
  sessoIntestatario: joi.string().required(),
  cellulareIntestatario: joi.string().required(),
  presenzaInstallazione: joi.string().required(),
  nomePresenzaInstallazione: joi.string().allow(null),
  cognomePresenzaInstallazione: joi.string().allow(null),
  cellularePresenzaInstallazione: joi.string().allow(null),
  emailPresenzaInstallazione: joi.string().allow(null),
  datiFatturaDiversiDaFornitura: joi.number().required(),
  tipoIndirizzoFatturazione: joi.string().allow(null),
  indirizzoFatturazione: joi.string().allow(null),
  civicoFatturazione: joi.string().allow(null),
  comuneFatturazione: joi.string().allow(null),
  capFatturazione: joi.string().allow(null),
  nomeFatturazione: joi.string().allow(null),
  cognomeFatturazione: joi.string().allow(null),
  dataDiNascitaFatturazione: joi.string().allow(null),
  comuneDiNascitaFatturazione: joi.string().allow(null),
  sessoFatturazione: joi.string().allow(null),
  codiceFiscaleFatturazione: joi.string().allow(null),
  cellulareFatturazione: joi.string().allow(null),
  emailFatturazione: joi.string().allow(null),
  tipoDocumento: joi.string().required(),
  numeroDocumento: joi.string().required(),
  comuneRilascioDocumento: joi.string().required(),
  dataRilascioDocumento: joi.string().required(),
  dataScadenzaDocumento: joi.string().required()
});
